#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;
using System.Globalization;

using Syncfusion.Pdf;
using Syncfusion.Pdf.Shared;

namespace Samples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		ITable table;
		PDFDocument pdfDoc;
		
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(112, 24);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(304, 70);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Essential PDF Samples";
			//this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//Create a new PDF Document. This object represents the whole PDF pdfDocument.
			//This pdfDocument had One page by default. Additional pages have to be added.
			pdfDoc = new PDFDocument();	
			
			//Accessing the first page in the pages collection.
			IPDFPage firstPage = pdfDoc.Pages[0];
			
			//Create a new PDF Table
			table = pdfDoc.CreateTable();

			//Importing first DataTable
			table.ImportDataTable(GetTable(11,2),true);
			formatTable();

			//Draw the first table to the specified page
			SizeF size = table.Publish( new PointF( 0,0 ),pdfDoc.Pages[0]);

			//Save the PDF pdfDocument to disk.
			pdfDoc.Save("BasicPDF.pdf");
			
			//Open the PDF pdfDocument that was created using Essential PDF.
			System.Diagnostics.Process.Start("BasicPDF.pdf");			
		}


		private DataTable GetTable(int row, int col)
		{
			DataTable dt = new DataTable("MyTable");
			string[] fields = new string[] {"Number", "Name", "Telephone", "Address1", "Address2", "Address3", 
											"SIC Description", "Company Type","Accounts Type", "Anual Return Date",
											"Incorporation Date" };

			string[] values = new string[] {"03731799","EURO SOFTWARE CONSULTING LIMITED","-","7A SOUTHWOOD HALL",
											  "MUSWELL HILL ROAD","LONDON","SOFTWARE PUBLISHING","Private limited with Share Capital",
											  "Total Excemption Small","12/03/2002","12/03/1999" };

			int nCols = col;
			int nRows = row;
			string str;

			for(int i = 0; i < nCols; i++)
			{
				if(i == 0) 
					str = "Base Information"; 
				else
					str=" ";

					dt.Columns.Add(new DataColumn(str));
			}

			for(int i = 0; i < nRows ; ++i)
			{
				DataRow dr = dt.NewRow();

				for(int j = 0; j < nCols; j++)					
				{
					if(j == 0)
						dr[j] = fields[i];
					else
						dr[j] = values[i];
				}

				dt.Rows.Add(dr);
			}
			return dt;
		}


		public void formatTable()
		{
			//Fonts to be used inside the table header rows and body rows.
			IPDFFont customersTableTitleFont = pdfDoc.Fonts.Add( new Font( "courier", 6, FontStyle.Bold )  );
			IPDFFont customersTableBodyFont = pdfDoc.Fonts.Add( new Font( "courier", 6, FontStyle.Regular )  );

			table.Columns[0].Width = 100;
			table.Columns[1].Width = 400;

			for(int i=0; i < table.Columns.Count; i++)
			{
				table.Header[0].Cells[i].Style.BordersWidth.All = 0;
				table.Header[0].Cells[i].Style.BackColor = Color.FromArgb(216,75,100);
				table.Header[0].Cells[i].Style.ForeColor = Color.White;
			}
				
			//Format the tables
			for( int i = 0; i < table.Rows.Count; ++i )
			{
				for(int j=0; j< table.Columns.Count;++j)
				{
					table.Rows[i].Cells[j].Style.BackColor = Color.FromArgb( 219, 226, 242 );
					table.Rows[i].Cells[j].Style.TextFont = customersTableBodyFont;
					table.Rows[i].Cells[j].Style.BordersWidth.All = 0;
				}
			}

			//To make the Table span over multiple pages without getting cut.
			table.PageBreakBehavior = AutoBreakBehavior.FullBreak;
		}
	}
}